// WiFi Remote Lチカ・クライアント

#include <WiFi.h>

#define SERVERPORT 23
const char* ssid     = "STAMP-PICO";
const char* password = "STAMP-PICO";
const char* host = "192.168.10.10";

#define LED_PIN 26
#define ID_PIN 36
#define BTN_PIN 18
int ledVal = LOW ;
int clientID = 0 ;

WiFiClient client;

void setup()
{
  Serial.begin(9600);
  delay(10);

  pinMode(LED_PIN,OUTPUT) ;
  digitalWrite(LED_PIN,LOW) ;

  pinMode(ID_PIN,INPUT) ;
  if (digitalRead(ID_PIN) == LOW) {
    clientID = 1 ;
  } else {
    clientID = 2 ;
  }

  pinMode(BTN_PIN,INPUT) ;
    
  // We start by connecting to a WiFi network
  Serial.println();
  Serial.println();
  Serial.print("Connecting to ");
  Serial.println(ssid);

  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
}

void loop()
{
  delay(500);
  if (digitalRead(BTN_PIN) == HIGH) {
    ledVal = (ledVal == HIGH) ? LOW : HIGH ;
  } else {
    return ;
  }

  Serial.print("connecting to ");
  Serial.println(host);

  if (WiFi.status() != WL_CONNECTED) {
    // WiFiが切れてたら再接続
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED) {
      delay(500);
      Serial.print(".");
    }
    Serial.println("");
    Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
  }

  // Use WiFiClient class to create TCP connections
  if (!client.connected( ) ) {
    if (!client.connect(host, SERVERPORT)) {
      Serial.println("connection failed");
      return;
    }
  }

  // This will send the request to the server
  digitalWrite(LED_PIN,LOW) ;
  client.print("LED") ;
  client.print(clientID) ;
  if (ledVal == HIGH) {
    client.println(":ON");
  } else {
    client.println(":OFF");
  }
  // Read all the lines of the reply from server and print them to Serial
  while(client.available()) {
    String line = client.readStringUntil('\r');
    Serial.print(line);
  }
}
